-- LFGListFrame.SearchPanel.results    --array of all resultID
-- buttons 1 to 9
-- LFGListSearchPanelScrollFrameButton6:Click("left",true);
-- LFGListFrame.SearchPanel.SignUpButton:Click("left",true);
-- LFGListSearchPanelScrollFrameButton6.resultID
-- LFGLIstSearchPanelScrollFrameScrollBar:SetValue(int)
-- LFGLIstSearchPanelScrollFrameScrollBar:GetValue()
-- LFGListSearchPanelScrollFrameScrollChild[int] 

-- updates results every few seconds specified by MultiFinder.refreshDeley
function MultiFinder:timer()
    MultiFinder.Results:SetScript("OnUpdate", function(self, elapsed)
        MultiFinder.elapsed = MultiFinder.elapsed or MultiFinder.refreshDeley;
        MultiFinder.elapsed = MultiFinder.elapsed - elapsed;
        if MultiFinder.elapsed <= 0 then
            MultiFinder.elapsed = MultiFinder.refreshDeley;
            MultiFinder:lookForLFGMatches(true)
        end
    end );
end

function MultiFinder:ClearResults()
 if MultiFinder.MainFrame.elap == nil then
    MultiFinder.index = MultiFinder.index or 0;
    for i = 0, MultiFinder.index do
        if not(MultiFinder.MainFrame.results[i] == nil) then
            if MultiFinder.MainFrame.results[i]:IsShown() then
                MultiFinder.MainFrame.results[i]:Hide();
            end
        end
    end
   end
end

function MultiFinder:DisplayResults()
    if MultiFinder.MainFrame.elap == nil then
    MultiFinder.index = 0;
    MultiFinder.MainFrame.data_index = 0;
    for a, c in pairs(MultiFinder.TempResultTable) do
        
        if (MultiFinder.MainFrame.data_index >= MultiFinder.Results.Slider.value - 5) and(MultiFinder.MainFrame.data_index < MultiFinder.Results.Slider.value + 5) then
           
            MultiFinder:CreateResult(MultiFinder.MainFrame.results[MultiFinder.index],
            "CustomMultiFinder_result" .. MultiFinder.index,
            c[1], MultiFinder.index)
            
            MultiFinder.index = MultiFinder.index + 1;
            if (MultiFinder.MainFrame.data_index >(MultiFinder.Results.Slider.value + 5)) then
                break;
            end
        end
        MultiFinder.MainFrame.data_index = MultiFinder.MainFrame.data_index + 1;
    end
    MultiFinder:SetSliderMax(MultiFinder.MainFrame.data_index);
    MultiFinder:Debug("Results Displayed");
    end
end



-- Trigers Search function and waits for 1 sec for results to update before continuing to Brains of operation
function MultiFinder:lookForLFGMatches(bypass_time_check)
    MultiFinder:Debug("search trigered")
    if bypass_time_check then
         C_LFGList.Search(MultiFinder.MainFrame.SearchID, ""); -- need to wait a sec or 2 for list to update
--        MultiFinder.MainFrame.elap = 0;
--        MultiFinder.MainFrame.wait = 1;
--        MultiFinder.MainFrame:SetScript("OnUpdate", function(self,elapsed)
--            MultiFinder.MainFrame.elap = MultiFinder.MainFrame.elap + elapsed;

--            if MultiFinder.MainFrame.elap > MultiFinder.MainFrame.wait then
--                MultiFinder.MainFrame:SetScript("OnUpdate", nil);
--                MultiFinder.MainFrame.elap = nil;
--                MultiFinder:lookForLFGMatchesCont(false);
--            end
--        end );
    end
end
-- Brains of the operation -



function MultiFinder:lookForLFGMatchesCont(bypass)
        MultiFinder:Debug("cont trigered")
        MultiFinder.MainFrame.Parameters = { strsplit(",", MultiFinder.MainFrame.Box:GetText(), nil) };
        --local num
        if not bypass then
        MultiFinder:Debug("get Results trigered")
            _,MultiFinder.MainFrame.data_b = C_LFGList.GetSearchResults(); --LFGListFrame.SearchPanel.results --C_LFGList.GetSearchResults();
        end
        --MultiFinder:Debug("# results: "..num);
        MultiFinder:ClearResults();

        MultiFinder.TempResultTable = { };
        
        for a, c in pairs(MultiFinder.MainFrame.data_b) do
            MultiFinder.MainFrame.data_str = select("3", C_LFGList.GetSearchResultInfo(c));
            MultiFinder.MainFrame.data_str = MultiFinder.MainFrame.data_str or " ";
            MultiFinder.MainFrame.data_matchStr = string.lower(MultiFinder.MainFrame.data_str);
            for j, param in pairs(MultiFinder.MainFrame.Parameters) do
                if not(string.find(MultiFinder.MainFrame.data_matchStr, string.lower(param)) == nil) then
                    -- Title contans search parameters
                    table.insert(MultiFinder.TempResultTable, { c, MultiFinder.MainFrame.data_str, select("7", C_LFGList.GetSearchResultInfo(c)) });

                end
            end
        end

        -- sort results by active duration

        local function sort()
            if table.getn(MultiFinder.TempResultTable) > 1 then
                table.sort(MultiFinder.TempResultTable, 
                function(a, b) 
                    if a[4] == nil then
                        a[4] = 0
                    end
                    if b[4] == nil then
                        b[4] = 0
                    end
                    
                    return a[4] > b[4] 
                end);
            end
        end
        if pcall(sort) then
        
        else
            sort();
        end;

        MultiFinder:DisplayResults()

end
